/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   mat4_scale.c                                       :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gbrochar <gbrochar@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2020/12/26 09:13:18 by gbrochar          #+#    #+#             */
/*   Updated: 2020/12/26 09:17:36 by gbrochar         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "mat4.h"

t_mat4			mat4_scale(t_mat4 m, t_vec3 s)
{
	t_mat4		ret;

	ret.data[0] = m.data[0] * s.x;
	ret.data[1] = m.data[1] * s.x;
	ret.data[2] = m.data[2] * s.x;
	ret.data[3] = m.data[3] * s.x;
	ret.data[4] = m.data[4] * s.y;
	ret.data[5] = m.data[5] * s.y;
	ret.data[6] = m.data[6] * s.y;
	ret.data[7] = m.data[7] * s.y;
	ret.data[8] = m.data[8] * s.z;
	ret.data[9] = m.data[9] * s.z;
	ret.data[10] = m.data[10] * s.z;
	ret.data[11] = m.data[11] * s.z;
	ret.data[12] = m.data[12];
	ret.data[13] = m.data[13];
	ret.data[14] = m.data[14];
	ret.data[15] = m.data[15];
	return (ret);
}