/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   mat4_transpose.c                                   :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gbrochar <gbrochar@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2020/12/22 20:34:52 by gbrochar          #+#    #+#             */
/*   Updated: 2020/12/23 10:50:15 by gbrochar         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "mat4.h"

t_mat4			mat4_transpose(t_mat4 m)
{
	t_mat4		out;

	out.data[0] = m.data[0];
	out.data[1] = m.data[4];
	out.data[2] = m.data[8];
	out.data[3] = m.data[12];
	out.data[4] = m.data[1];
	out.data[5] = m.data[5];
	out.data[6] = m.data[9];
	out.data[7] = m.data[13];
	out.data[8] = m.data[2];
	out.data[9] = m.data[6];
	out.data[10] = m.data[10];
	out.data[11] = m.data[14];
	out.data[12] = m.data[3];
	out.data[13] = m.data[7];
	out.data[14] = m.data[11];
	out.data[15] = m.data[15];
	return (out);
}
